VERSION 5.00
Begin VB.UserControl button2 
   AutoRedraw      =   -1  'True
   ClientHeight    =   1110
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3015
   ScaleHeight     =   74
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   201
   Begin VB.Label lblCaption 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "<CAPTION>"
      BeginProperty Font 
         Name            =   "BankGothic Lt BT"
         Size            =   8.25
         Charset         =   238
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FFFFFF&
      Height          =   210
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1455
   End
End
Attribute VB_Name = "button2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'
'   How to use this button:
'
'   ButtonStyle: the colour of the button
'
'   0 - green
'   1 - red
'   2 - blue
'

'Default Property Values:
'Const m_def_buttonWidth = 64
'Const m_def_buttonHeight = 24
Const m_def_ButtonStyle = 0
'Property Variables:
'Dim m_buttonWidth As Byte
'Dim m_buttonHeight As Byte
Dim m_ButtonStyle As Byte
'Event Declarations:
Event Click() 'MappingInfo=UserControl,UserControl,-1,Click
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Event DblClick() 'MappingInfo=UserControl,UserControl,-1,DblClick
Attribute DblClick.VB_Description = "Occurs when the user presses and releases a mouse button and then presses and releases it again over an object."

Const BUTTON_UP = 0
Const BUTTON_MOVE = 1
Const BUTTON_DOWN = 2

Dim colours(0 To 2, 0 To 4) As Long
'
''WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
''MappingInfo=UserControl,UserControl,-1,BackColor
'Public Property Get BackColor() As OLE_COLOR
'    BackColor = UserControl.BackColor
'End Property
'
'Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
'    UserControl.BackColor() = New_BackColor
'    PropertyChanged "BackColor"
'End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=lblCaption,lblCaption,-1,ForeColor
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
    ForeColor = lblCaption.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    lblCaption.ForeColor() = New_ForeColor
    PropertyChanged "ForeColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    UserControl.Enabled() = New_Enabled
    PropertyChanged "Enabled"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=lblCaption,lblCaption,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
    Set Font = lblCaption.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set lblCaption.Font = New_Font
    PropertyChanged "Font"
End Property

Private Sub lblCaption_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

    UserControl_MouseMove 1, 0, 0, 0

End Sub

Private Sub userControl_Click()
    'RaiseEvent Click
End Sub

Private Sub userControl_DblClick()
    RaiseEvent DblClick
    UserControl_MouseDown 1, 0, 0, 0
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=1,1,0,0
Public Property Get ButtonStyle() As Byte
Attribute ButtonStyle.VB_Description = "0 - green; 1 - red; 2 - blue"
    ButtonStyle = m_ButtonStyle
End Property

Public Property Let ButtonStyle(ByVal New_ButtonStyle As Byte)
    If Ambient.UserMode Then Err.Raise 382
    m_ButtonStyle = New_ButtonStyle
    PropertyChanged "ButtonStyle"
End Property

Private Sub UserControl_Initialize()

    colours(0, 0) = RGB(90, 190, 82)
    colours(0, 1) = RGB(49, 158, 49)
    colours(0, 2) = RGB(57, 142, 49)
    colours(0, 3) = RGB(49, 121, 49)
    colours(0, 4) = RGB(8, 60, 8)
    
    colours(1, 0) = RGB(231, 97, 82)
    colours(1, 1) = RGB(205, 82, 82)
    colours(1, 2) = RGB(206, 77, 74)
    colours(1, 3) = RGB(173, 77, 66)
    colours(1, 4) = RGB(69, 20, 20)
    
    colours(2, 0) = RGB(74, 97, 123)
    colours(2, 1) = RGB(57, 73, 99)
    colours(2, 2) = RGB(49, 60, 74)
    colours(2, 3) = RGB(41, 48, 66)
    colours(2, 4) = RGB(41, 48, 66)
    
End Sub

'Initialize Properties for User Control
Private Sub userControl_InitProperties()
    m_ButtonStyle = m_def_ButtonStyle
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

    UserControl.Line (0, 0)-(UserControl.ScaleWidth - 1, UserControl.ScaleHeight - 1), colours(m_ButtonStyle, 3), BF
    UserControl.Line (-1, -1)-(UserControl.ScaleWidth - 1, UserControl.ScaleHeight - 1), colours(m_ButtonStyle, 1), B
    UserControl.Line (0, 0)-(UserControl.ScaleWidth, UserControl.ScaleHeight), colours(m_ButtonStyle, 4), B
    lblCaption.Left = 1
    lblCaption.Top = Int(UserControl.ScaleHeight / 2 + 0.5) - 6

End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

    If (X < 0) Or (X > UserControl.ScaleWidth) Or (Y < 0) Or (Y > UserControl.ScaleHeight) Then  'the MOUSELEAVE pseudo-event
        ReleaseCapture
        UserControl.Line (0, 0)-(UserControl.ScaleWidth - 1, UserControl.ScaleHeight - 1), colours(m_ButtonStyle, 2), BF
        UserControl.Line (0, 0)-(UserControl.ScaleWidth - 1, UserControl.ScaleHeight - 1), colours(m_ButtonStyle, 4), B
        lblCaption.Top = Int(UserControl.ScaleHeight / 2 + 0.5) - 7
        lblCaption.Left = 0
    ElseIf GetCapture() <> UserControl.hWnd Then 'the MOUSEENTER pseudo-event
        SetCapture UserControl.hWnd
        UserControl.Line (0, 0)-(UserControl.ScaleWidth - 1, UserControl.ScaleHeight - 1), colours(m_ButtonStyle, 1), BF
        UserControl.Line (-1, -1)-(UserControl.ScaleWidth - 1, UserControl.ScaleHeight - 1), colours(m_ButtonStyle, 3), B
        UserControl.Line (0, 0)-(UserControl.ScaleWidth, UserControl.ScaleHeight), colours(m_ButtonStyle, 0), B
        lblCaption.Top = Int(UserControl.ScaleHeight / 2 + 0.5) - 7
        lblCaption.Left = 0
    End If
    
End Sub

Public Sub RefreshButton()

    UserControl.Line (0, 0)-(UserControl.ScaleWidth - 1, UserControl.ScaleHeight - 1), colours(m_ButtonStyle, 2), BF
    UserControl.Line (0, 0)-(UserControl.ScaleWidth - 1, UserControl.ScaleHeight - 1), colours(m_ButtonStyle, 4), B
    lblCaption.width = UserControl.ScaleWidth
    lblCaption.Left = 0
    lblCaption.Top = Int(UserControl.ScaleHeight / 2 + 0.5) - 7

End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

    RaiseEvent Click

End Sub

'Load property values from storage
Private Sub userControl_ReadProperties(PropBag As PropertyBag)

    lblCaption.ForeColor = PropBag.ReadProperty("ForeColor", &H80000012)
    UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
    Set lblCaption.Font = PropBag.ReadProperty("Font", Ambient.Font)
    m_ButtonStyle = PropBag.ReadProperty("ButtonStyle", m_def_ButtonStyle)
    
    lblCaption.Caption = PropBag.ReadProperty("Caption", "<CAPTION>")

End Sub

'Write property values to storage
Private Sub userControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("ForeColor", lblCaption.ForeColor, &H80000012)
    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call PropBag.WriteProperty("Font", lblCaption.Font, Ambient.Font)
    Call PropBag.WriteProperty("ButtonStyle", m_ButtonStyle, m_def_ButtonStyle)
    
    Call PropBag.WriteProperty("Caption", lblCaption.Caption, "<CAPTION>")

End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=lblCaption,lblCaption,-1,Caption
Public Property Get Caption() As String
Attribute Caption.VB_Description = "Returns/sets the text displayed in an object's title bar or below an object's icon."
    Caption = lblCaption.Caption
End Property

Public Property Let Caption(ByVal New_Caption As String)
    lblCaption.Caption() = New_Caption
    PropertyChanged "Caption"

End Property
